<?php

namespace OCA\GrueneGroupfolderManagement\DTO;

use Respect\Validation\Validator as v;

class AddGroupMemberDto {
	public function __construct(
		public string $mappingId,
		public string $mappingType,
		public string $type,
	) {
	}

	public static function GetValidator(): v {
		return v::create()
			->key('mappingId', v::stringType())
			->key('mappingType', v::stringVal()->oneOf(
				v::equals('group'),
				v::equals('user'),
			)->setTemplate('must be group or user'))
			->key('type', v::stringVal()->oneOf(
				v::equals('member'),
				v::equals('admin'),
			)->setTemplate('must be member or admin'))
		;
	}
}
