<?php

namespace OCA\GrueneGroupfolderManagement\DTO;

use Respect\Validation\Validator as v;

class CreateGroupDto {
	public function __construct(
		public string $name,
		public string $divisionKey,
		public string $type,
	) {
	}

	public static function GetValidator(): v {
		return v::create()
			->key('name', v::stringType()->length(3, 255))
			->key('divisionKey', v::stringType()->length(8, 8)->digit())
			->key('type', v::stringVal()->oneOf(
				v::equals('OTHER'),
				v::equals('WORKGROUP'),
				v::equals('EXECUTIVE_BOARD'),
			)->setTemplate('must be one of OTHER, WORKGROUP or EXECUTIVE_BOARD'))
		;
	}
}
