<?php

namespace OCA\GrueneGroupfolderManagement\Db;

use JsonSerializable;

use OCA\GrueneGroupfolderManagement\Model\Division;
use OCP\AppFramework\Db\Entity;

class Group extends Entity implements JsonSerializable {
	/**
	 * @var string
	 */
	protected $name;

	/**
	 * @var string
	 */
	protected $divisionKey;

	/**
	 * @var int
	 */
	protected $divisionAclPermission;

	/**
	 * @var int
	 */
	protected $divisionAclMask;

	/**
	 * @var int
	 */
	protected $memberAclPermission;

	/**
	 * @var int
	 */
	protected $memberAclMask;

	/**
	 * @var int
	 */
	protected $adminAclPermission;

	/**
	 * @var int
	 */
	protected $adminAclMask;

	/**
	 * @var string
	 */
	protected $type;

	/**
	 * @var bool
	 */
	protected $active;

	/**
	 * @var Division
	 */
	protected $division;

	public function __construct() {
		$this->addType('divisionAclMask', 'integer');
		$this->addType('divisionAclPermission', 'integer');
		$this->addType('memberAclMask', 'integer');
		$this->addType('memberAclPermission', 'integer');
		$this->addType('adminAclMask', 'integer');
		$this->addType('adminAclPermission', 'integer');
		$this->addType('active', 'boolean');
	}

	/**
	 * @return Division
	 */
	public function getDivision() {
		return $this->division;
	}

	/**
	 * @param Division
	 */
	public function setDivision(Division $division) {
		$this->division = $division;
	}

	public function setFields(array|object $fields): self {
		if ('object' === gettype($fields)) {
			$fields = get_object_vars($fields);
		}
		$fields = array_filter($fields, fn ($val) => $val !== null);

		foreach ($fields as $key => $value) {
			$setter = "set" . ucfirst($key);
			$this->$setter($value);
		}
		return $this;
	}

	public function jsonSerialize(): mixed {
		return [
			'id' => $this->id,
			'name' => $this->name,
			'divisionKey' => $this->divisionKey,
			'divisionAclPermission' => $this->divisionAclPermission,
			'divisionAclMask' => $this->divisionAclMask,
			'memberAclPermission' => $this->memberAclPermission,
			'memberAclMask' => $this->memberAclMask,
			'adminAclPermission' => $this->adminAclPermission,
			'adminAclMask' => $this->adminAclMask,
			'type' => $this->type,
			'active' => $this->active
		];
	}
}
