<?php

declare(strict_types=1);

namespace OCA\GrueneGroupfolderManagement\Migration;

use Closure;
use OCP\IDBConnection;
use OCP\DB\ISchemaWrapper;
use OCP\DB\Types;
use OCP\Migration\IOutput;
use OCP\Migration\SimpleMigrationStep;

/**
 * Auto-generated migration step: Please modify to your needs!
 */
class Version0010Date20210930144237 extends SimpleMigrationStep {
	/** @var IDBConnection */
	private $connection;

	private $hasActiveColumn;

	public function __construct(IDBConnection $connection) {
		$this->connection = $connection;
	}


	public function preSchemaChange(IOutput $output, \Closure $schemaClosure, array $options) {
		/** @var ISchemaWrapper $schema */
		$schema = $schemaClosure();
		$table = $schema->getTable('gruenegfm_division_groups');
		$this->hasActiveColumn = $table->hasColumn('active');
	}


	public function changeSchema(IOutput $output, Closure $schemaClosure, array $options): ?ISchemaWrapper {
		/** @var ISchemaWrapper $schema */
		$schema = $schemaClosure();
		$table = $schema->getTable('gruenegfm_division_groups');
		if (!$table->hasColumn('active')) {
			$table->addColumn('active', Types::BOOLEAN, [
				'notnull' => false,
				'default' => true
			]);
		}
		return $schema;
	}


	public function postSchemaChange(IOutput $output, \Closure $schemaClosure, array $options) {
		if (!$this->hasActiveColumn) {
			$query = $this->connection->getQueryBuilder();
			$query->update('gruenegfm_division_groups')
				->set('active', $query->createNamedParameter(true));
		}
	}
}
